# ==================================================================
# Plugins::Thumb_Images - Auto Generated Install Module
#
#   Plugins::Thumb_Images
#   Author  : Andy Newby
#   Version : 7.0.2
#   Updated : 8th Jan 2013
#
# ==================================================================
#

package Plugins::Thumb_Images;
# ==================================================================
use strict;
use vars  qw/$VERSION $DEBUG $NAME $META/;
use GT::Base;
use GT::Plugins qw/STOP CONTINUE/;
use Links qw/:objects/;

$VERSION = '7.0.2';
$DEBUG   = 0;
$NAME    = 'Thumb_Images';
# Inhert from base class for debug and error methods
@Plugins::Thumb_Images::ISA = qw(GT::Base);

$META = {
    'author' => 'Andy Newby',
    'description' => 'This plugin will automate the conversion of images in your GLinks system for Categories, Links and Reviews',
    'license' => 'Commercial',
    'prog_ver' => '3.3.0',
    'url' => 'http://www.ultranerds.co.uk',
    'version' => '7.0.2'
};


sub pre_install {
# -----------------------------------------------------------------------------
# This function displays an HTML formatted message that will display any
# instructions/information to the user before they install the plugin.
#
    my $inst_msg = '';

    return $inst_msg;
}

sub pre_uninstall {
# -----------------------------------------------------------------------------
# This function displays an HTML formatted message that will display any
# instructions/information to the user before they remove the plugin.
#
    my $uninst_msg = '';

    return $uninst_msg;
}

sub install {
# -----------------------------------------------------------------------------
# This function does the actual installation.  Its first argument is a plugin
# manager which you can use to register hooks, install files, add menu options,
# etc.  The second argument is a GT::Tar object which you can use to access any
# files in your plugin module.
#
# You should return an HTML formatted string that will be displayed to the
# user.
#
# If there is an error, return undef, and set the error message in
# $Plugins::Thumb_Images::error
#
    my ($mgr, $tar) = @_;
    
    $mgr->install_hooks('Thumb_Images', [['add_link', 'POST', 'Plugins::Thumb_Images::add_link', '']]);

    $mgr->install_hooks('Thumb_Images', [['user_modify_link', 'PRE', 'Plugins::Thumb_Images::check_if_should_run', '']]);
    $mgr->install_hooks('Thumb_Images', [['user_modify_link', 'POST', 'Plugins::Thumb_Images::user_modify_link', '']]);

    $mgr->install_hooks('Thumb_Images', [['modify_link', 'PRE', 'Plugins::Thumb_Images::check_if_should_run', '']]);
    $mgr->install_hooks('Thumb_Images', [['modify_link', 'POST', 'Plugins::Thumb_Images::admin_modify_link', '']]);

    $mgr->install_hooks('Thumb_Images', [['validate_link', 'PRE', 'Plugins::Thumb_Images::check_if_should_run', '']]);
    $mgr->install_hooks('Thumb_Images', [['validate_link', 'POST', 'Plugins::Thumb_Images::validate_link', '']]);

    $mgr->install_hooks('Thumb_Images', [['add_category', 'PRE', 'Plugins::Thumb_Images::add_category', '']]);

    $mgr->install_hooks('Thumb_Images', [['modify_category', 'PRE', 'Plugins::Thumb_Images::check_if_should_run', '']]);
    $mgr->install_hooks('Thumb_Images', [['modify_category', 'POST', 'Plugins::Thumb_Images::modify_category', '']]);

    $mgr->install_hooks('Thumb_Images', [['validate_review', 'PRE', 'Plugins::Thumb_Images::validate_review', '']]);

    $mgr->install_hooks('Thumb_Images', [['add_this_review', 'POST', 'Plugins::Thumb_Images::review_add', '']]);

    $mgr->install_menu('Thumb_Images', [['Readme', 'admin.cgi?do=plugin&plugin=Thumb_Images&func=Readme']]);
    $mgr->install_menu('Thumb_Images', [['Cleanup', 'admin.cgi?do=plugin&plugin=Thumb_Images&func=Cleanup']]);
    $mgr->install_menu('Thumb_Images', [['Setup', 'admin.cgi?do=page&page=plugin_manager.html&plugin_man_do=edit_installed&plugin_name=Thumb_Images']]);
    $mgr->install_options('Thumb_Images', [['links_fields', '', 'Set these like:<br />
<br />
Image1::200x200::small<br />
Image1::300x300::medium<br />
Image1::400x400::large<br />
<br />
You can define as many different sizes for each field as you want.', 'TEXTAREA', [], [], '']]);

    $mgr->install_options('Thumb_Images', [['review_fields', '', 'Set these like:<br />
<br />
Image1::200x200::small<br />
Image1::300x300::medium<br />
Image1::400x400::large<br />
<br />
You can define as many different sizes for each field as you want.', 'TEXTAREA', [], [], '']]);

    $mgr->install_options('Thumb_Images', [['category_fields', '', 'Set these like:<br />
<br />
Image1::200x200::small<br />
Image1::300x300::medium<br />
Image1::400x400::large<br />
<br />
You can define as many different sizes for each field as you want.', 'TEXTAREA', [], [], '']]);
    $mgr->install_options('Thumb_Images', [['WayToConvert', 'command', 'Please decide which method you wish to use to do your conversions.', 'SELECT', ['Command Line (recommended, as its faster)','Image::Magick Perl module'], ['command','module'], '']]);
    ;
    return "The plugin has been successfully installed!";
}

sub uninstall {
# -----------------------------------------------------------------------------
# This function removes the plugin.  Its first argument is also a plugin
# manager which you can use to register hooks, install files, add menu options,
# etc. You should return an HTML formatted string that will be displayed to the
# user.
#
# If there is an error, return undef, and set the error message in
# $Plugins::Thumb_Images::error
#
    my $mgr = shift;
    
    $mgr->uninstall_hooks('Thumb_Images', [['add_link', 'POST', 'Plugins::Thumb_Images::add_link', '']]);
    $mgr->uninstall_hooks('Thumb_Images', [['user_modify_link', 'POST', 'Plugins::Thumb_Images::user_modify_link', '']]);
    $mgr->uninstall_hooks('Thumb_Images', [['modify_link', 'POST', 'Plugins::Thumb_Images::admin_modify_link', '']]);    $mgr->uninstall_menu('Thumb_Images', [['Readme', 'admin.cgi?do=plugin&plugin=Thumb_Images&func=Readme']]);    $mgr->uninstall_menu('Thumb_Images', [['Cleanup', 'admin.cgi?do=plugin&plugin=Thumb_Images&func=Cleanup']]);    $mgr->uninstall_menu('Thumb_Images', [['Setup', 'admin.cgi?do=page&page=plugin_manager.html&plugin_man_do=edit_installed&plugin_name=Thumb_Images']]);
    $mgr->uninstall_options('Thumb_Images', [['links_fields', '', 'Set these like: \
\
Image1::200x200::small\
Image1::300x300::medium\
Image1::400x400::large\
\
You can define as many different sizes for each field as you want.', 'TEXTAREA', [], [], '']]);
    $mgr->uninstall_options('Thumb_Images', [['WayToConvert', 'command', 'Please decide which method you wish to use to do your conversions.', 'SELECT', ['command','module'], ['Command Line (recommended, as its faster)','Image::Magick Perl module'], '']]);
    ;
    return "The plugin has been successfully removed!";
}

1;
